#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                                       Pedro2.mq4 |
//|                                                                  |
//|                                                                  |
//|                                        Converted by Mql2Mq4 v0.6 |
//|                                            http://yousky.free.fr |
//|                                    Copyright  2006, Yousky Soft |
//+------------------------------------------------------------------+

#property copyright " Pedro Echenagucia"
#property link      ""


//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+
extern double Lots = 1.00;
extern double StopLoss = 30.00;
extern double TakeProfit = 50.00;
extern double TrailingStop = 0.00;

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double GAP = 20;
extern double MaxTrades = 3;
extern double Inverted = 0;
extern double ReEntryGAP = 5;
extern double tStop = 0;
extern double tPips = 0;
extern double StartHour = 9;
extern double EndHour = 14;
extern bool MM = 0;
extern double MaxLots = 50;
extern double StartYear = 2005;
extern double Entry = 0;
extern double ReEntry = 0;
extern double Dir = 0;

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;

bool MOrderModify( int ticket, double price, double stoploss, double takeprofit, datetime expiration, color arrow_color=CLR_NONE)
{
  LastTradeTime = CurTime();
  price = MathRound(price*10000)/10000;
  stoploss = MathRound(stoploss*10000)/10000;
  takeprofit = MathRound(takeprofit*10000)/10000;
  return ( OrderModify( ticket, price, stoploss, takeprofit, expiration, arrow_color) );
}

int MOrderSend( string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment="", int magic=0, datetime expiration=0, color arrow_color=CLR_NONE)
{
  LastTradeTime = CurTime();
  price = MathRound(price*10000)/10000;
  stoploss = MathRound(stoploss*10000)/10000;
  takeprofit = MathRound(takeprofit*10000)/10000;
  return ( OrderSend( symbol, cmd, volume, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color ) );
}

int OrderValueTicket(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderTicket());
}

int OrderValueType(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderType());
}

double OrderValueOpenPrice(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderOpenPrice());
}

double OrderValueStopLoss(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderStopLoss());
}

double OrderValueTakeProfit(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderTakeProfit());
}

string OrderValueSymbol(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderSymbol());
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
int i = 0;
double nLots = 0;
double nTrades = 0;

/*[[
	Name := Venezuelan Investment Group
	Author := Pedro Echenagucia
	Link   := http://www.veninvgroup.com/
	Lots := 1.00
	Stop Loss := 30
	Take Profit := 50
	Trailing Stop := 0
]]*/

 
 
 

if( Year()<StartYear ) return(0);

if( TrailingStop != 0 ) {
	for(i=1;i<=OrdersTotal();i++) {
		if( OrderValueSymbol(1) == Symbol() ) {
			switch( OrderValueType(i) ) {
				case OP_BUY:				
					if( OrderValueStopLoss(i)<Ask-TrailingStop*Point ) 
						MOrderModify(OrderValueTicket(i),OrderValueOpenPrice(i),Ask-TrailingStop*Point, OrderValueTakeProfit(i),0, Blue);
				case OP_SELL:
					if( OrderValueStopLoss(i)>Bid+TrailingStop*Point ) 
						MOrderModify(OrderValueTicket(i),OrderValueOpenPrice(i),Bid+TrailingStop*Point, OrderValueTakeProfit(i),0, Blue);
			}

		}
	}
}

if( tStop != 0 ) {
	for(i=1;i<=OrdersTotal();i++) {
		if( OrderValueSymbol(1) == Symbol() ) {
			switch( OrderValueType(i) ) {
				case OP_BUY:				
					if( OrderValueStopLoss(i)<OrderValueOpenPrice(i) && Ask>=OrderValueOpenPrice(i)+tStop*Point ) 
						MOrderModify(OrderValueTicket(i),OrderValueOpenPrice(i),OrderValueOpenPrice(i)+tPips*Point, OrderValueTakeProfit(i),0, Blue);
				case OP_SELL:
					if( OrderValueStopLoss(i)>OrderValueOpenPrice(i) && Bid<=OrderValueOpenPrice(i)-tStop*Point ) 
						MOrderModify(OrderValueTicket(i),OrderValueOpenPrice(i),OrderValueOpenPrice(i)-tPips*Point, OrderValueTakeProfit(i),0, Red);					
			}

		}
	}
}

if( Hour()<StartHour ) {
	Entry=0;
//	ReEntry=0;
	return(0);
}

if( Hour()>EndHour ) {
	Entry=0;
//	ReEntry=0;
	return(0);
}

nTrades=0;
if( OrdersTotal() > 0 ) {	
	for(i=1;i<=OrdersTotal();i++) {
		if( OrderValueSymbol(i) == Symbol() ) nTrades++;
	}
}

if( nTrades>=MaxTrades ) return(0);

if( MM ) {
	nLots = MathFloor(AccountEquity()/20000);
	if( nLots < 1 ) nLots=1;
	if( nLots > MaxLots ) nLots=MaxLots;
}  else {
	nLots=Lots;
}

if( Entry != 0) {
	if( Ask>=Entry+GAP*Point ) {
		MOrderSend(Symbol(),OP_BUY,nLots,Ask,1,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",16384,0,Blue);
		ReEntry=Ask;		
		Print("ReEntry ",ReEntry, " Time ",TimeToStr(CurTime()));
		Entry=0;
		Dir=1;
		return(0);
	}
	
	if( Ask<=Entry-GAP*Point ) {	
		MOrderSend(Symbol(),OP_SELL,nLots,Bid,1,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",16384,0,Red);		
		ReEntry=Ask;
		Print("ReEntry ",ReEntry, " Time ",TimeToStr(CurTime()));
		Entry=0;
		Dir=2;
		return(0);
	}
}  else {
	if( nTrades == 0 ) {
		Entry=Ask;
		Print("Entry ",Entry, " Time ",TimeToStr(CurTime()));
		ReEntry=0;
	}
}

if( ReEntry != 0) {
	if( Dir == 1 ) {
		if( Ask>=ReEntry+ReEntryGAP*Point ) {
			MOrderSend(Symbol(),OP_BUY,nLots,Ask,1,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",16384,0,Blue);
			if( nTrades+1<MaxTrades ) ReEntry=Ask ; else ReEntry=0;
			Print("ReEntry ",ReEntry, " Time ",TimeToStr(CurTime()));
			return(0);
		}
	}
	
	if( Dir == 2 ) {
		if( Ask<=ReEntry-ReEntryGAP*Point ) {	
			MOrderSend(Symbol(),OP_SELL,nLots,Bid,1,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",16384,0,Red);
			if( nTrades+1<MaxTrades ) ReEntry=Ask ; else ReEntry=0;
			Print("ReEntry ",ReEntry, " Time ",TimeToStr(CurTime()));
			return(0);
		}
	}
}
  return(0);
}